
Redmine - Patch #26711

Use pluck instead of collect/map

2017-08-17 05:03 - jwjw yy

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Performance Estimated time: 0.00 hour

Target version: 4.0.0   

Description

In app/helpers/my_helpers,

68:     where(:project_id => User.current.projects.map(&:id)).

Use pluck to get the id is much more efficient, since the query will only access the id field, instead of select * from projects:

Before:

SELECT `projects`.* FROM `projects` INNER JOIN `members` ON `projects`.`id` = `members`.`project_id` WHERE

`members`.`user_id` = ? AND (projects.status<>9)  "user_id", 5341

After:

SELECT `projects`.`id` FROM `projects` INNER JOIN `members` ON `projects`.`id` = `members`.`project_id` WHERE

`members`.`user_id` = ? AND (projects.status<>9)  "user_id", 5341

Related issues:

Related to Redmine - Patch #26726: Use pluck(:id) instead of collect(&:id) Closed

Associated revisions

Revision 17036 - 2017-11-26 15:37 - Go MAEDA

Use pluck instead of map in MyHelper (#26711).

Patch by jwjw yy.

Revision 17454 - 2018-07-28 17:24 - Go MAEDA

Use pluck(:id) instead of collect(&:id) (#26711).

Patch by jwjw yy.

Revision 17455 - 2018-07-29 07:45 - Go MAEDA

Use pluck(:id) instead of collect(&:id) in app/models/issue.rb (#26711).

History

#1 - 2017-08-17 05:49 - Toshi MARUYAMA

- Category set to Code cleanup/refactoring

- Target version set to 4.1.0

#2 - 2017-08-17 05:49 - Toshi MARUYAMA

- Tracker changed from Defect to Patch

#3 - 2017-08-17 06:05 - Go MAEDA

Index: app/helpers/my_helper.rb

===================================================================

--- app/helpers/my_helper.rb    (revision 16952)

+++ app/helpers/my_helper.rb    (working copy)

@@ -78,7 +78,7 @@

   def render_calendar_block(block, settings)

     calendar = Redmine::Helpers::Calendar.new(User.current.today, current_language, :week)

     calendar.events = Issue.visible.

-      where(:project_id => User.current.projects.map(&:id)).

+      where(:project_id => User.current.projects.pluck(:id)).

       where("(start_date>=? and start_date<=?) or (due_date>=? and due_date<=?)", calendar.startdt, calendar.

enddt, calendar.startdt, calendar.enddt).

       includes(:project, :tracker, :priority, :assigned_to).
       references(:project, :tracker, :priority, :assigned_to).

@@ -139,7 +139,7 @@

   def render_news_block(block, settings)

     news = News.visible.

-      where(:project_id => User.current.projects.map(&:id)).

+      where(:project_id => User.current.projects.pluck(:id)).

       limit(10).

       includes(:project, :author).

       references(:project, :author).

#4 - 2017-11-26 15:40 - Go MAEDA

- Subject changed from .map should be changed to .pluck to Use pluck instead of map in MyHelper

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Target version changed from 4.1.0 to 4.0.0

Commited in the trunk. Thank you for pointing it out.

#5 - 2018-07-28 17:20 - Go MAEDA

- Subject changed from Use pluck instead of map in MyHelper to Use pluck instead of collect/map

- Category changed from Code cleanup/refactoring to Performance

#6 - 2018-07-28 17:21 - Go MAEDA

- Related to Patch #26726: Use pluck(:id) instead of collect(&:id)  added
